from rich.text import Text
from .format import Color, get_animated_messages, get_colored_message, get_plain_message

_BLESSING = r"""
      `--._    `-._   `-.   `.  \   :   /  .'   .-'   _.-'    _.--'
`--.__     `--._   `-._  `-.  `. `. : .' .'  .-'  _.-'   _.--'     __.--'
__    `--.__    `--._  `-._ `-. `. \:/ .' .-' _.-'  _.--'    __.--'    __
  `--..__   `--.__   `--._ `-._`-.`_=_'.-'_.-' _.--'   __.--'   __..--'
--..__   `--..__  `--.__  `--._`-q(-_-)p-'_.--'  __.--'  __..--'   __..--
      ``--..__  `--..__ `--.__ `-'_) (_`-' __.--' __..--'  __..--''
...___        ``--..__ `--..__`--/__/  \--'__..--' __..--''        ___...
      ```---...___    ``--..__`_(<_   _/)_'__..--''    ___...---'''
```-----....._____```---...___(__\_\_|_/__)___...---'''_____.....-----'''
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                        God Bless        Never Crash

"""

_PRAYER_TEMPLATE = r"""{1}
      `--._    `-._   `-.   `.  \   :   /  .'   .-'   _.-'    _.--'
`--.__     `--._   `-._  `-.  `. `. : .' .'  .-'  _.-'   _.--'     __.--'
__    `--.__    `--._  `-._ `-. `. {0}\:/{1} .' .-' _.-'  _.--'    __.--'    __
  `--..__   `--.__   `--._ `-._`-{0}.`{1}_=_{0}'.{1}-'_.-' _.--'   __.--'   __..--'
--..__   `--..__  `--.__  `--.{0}_`-{1}q(-_-)p{0}-'_{1}.--'  __.--'  __..--'   __..--
      ``--..__  `--..__ `--.__ `{0}-'{1}_) (_{0}`-{1}' __.--' __..--'  __..--''
...___        ``--..__ `--..__{0}`--{1}{{animation}}{0}--'{1}__..--' __..--''        ___...
      ```---...__     ``--..{0}__`{1}_(<_   _/)_{0}'__{1}..--''    ___...---'''
```-----....._____```---..._{0}__{1}(__\_\_|_/__){0}__{1}_...---'''_____.....-----'''
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^{0}^^^^^^^^^^^^^^^{1}^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                        {0}N a m u a m i t a b u l ~{1}

"""
_PRAYER_COLORED_TEMPLATE = get_colored_message(_PRAYER_TEMPLATE, highlight=Color.YELLOW)
_PRAYER_ANIMATED = get_animated_messages(_PRAYER_COLORED_TEMPLATE, ["/___||_)", "(_||___\\"])
_PRAYER = get_plain_message(_PRAYER_TEMPLATE).format(animation="/__|__\\")

_HURRAY_TEMPLATE = r"""
      `--._    `-._   `-.   `.  \   :   /  .'   .-'   _.-'    _.--'
`--.__     `--._   `-._  `-.  `. `. : .' .'  .-'  _.-'   _.--'     __.--'
__    `--.__    `--._  `-._ `-. `. \:/ .' .-' _.-'  _.--'    __.--'    __
  `--..__   `--.__   `--._ `-._`-.`_=_'.-'_.-' _.--'   __.--'   __..--'
--..__   `--..__  `--.__  `--._`-q(•u{animation}-'_.--'  __.--'  __..--'   __..--
      ``--..__  `--..__ `--.__ `-'_) (_`-' __.--' __..--'  __..--''
...___        ``--..__ `--..__`--/__/  \--'__..--' __..--''        ___...
      ```---...___    ``--..__`_(<_   _/)_'__..--''    ___...---'''
```-----....._____```---...___(__\_\_|_/__)___...---'''_____.....-----'''
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                  May no obstacle come across your way

"""
_HURRAY_ANIMATED = get_animated_messages(
      _HURRAY_TEMPLATE,
      ["•)p", get_colored_message("-){0}⟡{1}", highlight=Color.CYAN)]
)
_HURRAY = _HURRAY_ANIMATED[0]

_ERROR_TEMPLATE = r"""{0}
      `--._    `-._   `-.   `.  \   :   /  .'   .-'   _.-'    _.--'
`--.__     `--._   `-._  `-.  `. `. : .' .'  .-'  _.-'   _.--'     __.--'
__    `--.__    `--._  `-._ `-. `. \:/ .' .-' _.-'  _.--'    __.--'    __
  `--..__   `--.__   `--._ `-._`-.`{1}_=_{0}'.-'_.-' _.--'   __.--'   __..--'
--..__   `--..__  `--.__  `--._`-{1}q(⊙_⊙)p{0}-'_.--'  __.--'  __..--'   __..--
      ``--..__  `--..__ `--.__ `-'{1}_) (_{0}`-' __.--' __..--'  __..--''
...___        ``--..__ `--..__`--{1}/__/  \\{0}--'__..--' __..--''        ___...
      ```---...___    ``--..__`{1}_(<_   _/)_{0}'__..--''    ___...---'''
```-----....._____```---...___{1}(__\_\_|_/__){0}___...---'''_____.....-----'''
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                      """
_ERROR_COLORED = get_colored_message(_ERROR_TEMPLATE, highlight=Color.RED)
_ERROR_TO_ANIMATE = """ALL within the palm of my hand
"""
_ERROR = get_plain_message([_ERROR_TEMPLATE, _ERROR_TO_ANIMATE])


class Message:
      """Importable messages for the BlessedConsole"""
      
      BLESSING = Text(_BLESSING)
      PRAYER = Text(_PRAYER)
      HURRAY = Text(_HURRAY)
      ERROR = Text(_ERROR)
